//Strings.cpp
#include  <stdlib.h>
#include  <stdio.h>
#include  <string.h>
#include  "Strings.h"

String::String()    //Uninitialized Constructor
{
 puts("Entering String()  Uninitialized Constructor");   
 pStrBuffer=new char[MINIMUM_ALLOCATION];
 printf("  this = %u\n",(unsigned int)this);
 printf("  pStrBuffer = %u\n",(unsigned int)pStrBuffer);
 pStrBuffer[0]='\0';
 this->iAllowableCharacterCount=MINIMUM_ALLOCATION-1;
 puts("Leaving Uninitialized Constructor\n");   
}


String::String(const char ch)  //Constructor: Initializes with char
{
 pStrBuffer=new char[MINIMUM_ALLOCATION];
 pStrBuffer[0]=ch;
 pStrBuffer[1]='\0';
 iAllowableCharacterCount=MINIMUM_ALLOCATION-1;
}


String::String(const char* pStr)  //Constructor: Initializes with char*
{
 int iLen,iNewSize;

 puts("Entering String(const char* pStr)  //Constructor: Initializes with char*");
 printf("  this = %u\n", (unsigned int)this);
 printf("  pStr = %s\n",pStr); 
 iLen=strlen(pStr);
 iNewSize=(iLen/16+1)*16;
 pStrBuffer=new char[iNewSize];
 this->iAllowableCharacterCount=iNewSize-1;
 strcpy(pStrBuffer,pStr);
 printf("  pStrBuffer = %u\t%s\n",(unsigned int)pStrBuffer,pStrBuffer); 
 
 puts("Leaving String(const char* pStr)\n"); 
}


String::String(const String& s)  //Constructor Initializes With Another String, i.e., Copy Constructor
{
 int iLen,iNewSize;

 puts("Entering String(const String& s) Copy Constructor");
 iLen=strlen(s.pStrBuffer);
 iNewSize=(iLen/16+1)*16;
 this->pStrBuffer=new char[iNewSize];
 this->iAllowableCharacterCount=iNewSize-1;
 strcpy(this->pStrBuffer,s.pStrBuffer);
 printf("  this       = %u\n",(unsigned int)this);
 printf("  pStrBuffer = %u\n",(unsigned int)pStrBuffer);
 puts("Leaving String(const String& s) Copy Constructor\n");
}


String::String(const int iSize)  //Constructor Creates String With Custom Sized
{                                //Buffer (rounded up to paragraph boundary)
 int iNewSize;

 iNewSize=(iSize/16+1)*16;
 pStrBuffer=new char[iNewSize];
 this->iAllowableCharacterCount=iNewSize-1;
}


String& String::operator=(const char ch)  //Overloaded operator = for assigning a character to a String
{
 this->pStrBuffer[0]=ch;
 this->pStrBuffer[1]='\0';

 return *this;
}


String& String::operator=(const char* pStr)   //Constructor For If Pointer To Asciiz String Parameter
{
 int iLen,iNewSize;

 puts("  Entering String::operator=(const char* pStr)");
 iLen=strlen(pStr);
 if(iLen<this->iAllowableCharacterCount)
 {
    strcpy(pStrBuffer,pStr);
    printf("    pStr = %u\t%s\n",(unsigned int)pStrBuffer,pStrBuffer);   
 }   
 else
 {
    delete [] pStrBuffer;
    iNewSize=(iLen/16+1)*16;
    pStrBuffer=new char[iNewSize];
    this->iAllowableCharacterCount=iNewSize-1;
    strcpy(pStrBuffer,pStr);
    printf("    pStr = %u\t%s\n",(unsigned int)pStrBuffer,pStrBuffer);
 }
 puts("  Leaving String::operator=(const char* pStr)\n");

 return *this;
}


String& String::operator=(const String& strRight)  //Overloaded operator = for
{                                                  //assigning another String to
 int iRightLen,iNewSize;                           //a String

 if(this==&strRight)
    return *this;
 iRightLen=strlen(strRight.pStrBuffer);
 if(iRightLen < this->iAllowableCharacterCount)
    strcpy(pStrBuffer,strRight.pStrBuffer);
 else
 {
    iNewSize=(iRightLen/16+1)*16;
    delete [] this->pStrBuffer;
    this->pStrBuffer=new char[iNewSize];
    this->iAllowableCharacterCount=iNewSize-1;
    strcpy(pStrBuffer,strRight.pStrBuffer);
 }
 
 return *this;
}



bool String::operator==(const String strCompare)
{
 if(strcmp(this->pStrBuffer,strCompare.pStrBuffer)==0)  //strcmp
    return true;
 else
    return false;
}


String& String::operator+(const char ch)      //Overloaded operator + (Puts char in String)
{
 int iLen,iNewSize;
 char* pNew;

 iLen=strlen(this->pStrBuffer);
 if(iLen<this->iAllowableCharacterCount)
 {
    this->pStrBuffer[iLen]=ch;
    this->pStrBuffer[iLen+1]='\0';
 }
 else
 {
    iNewSize=((this->iAllowableCharacterCount*EXPANSION_FACTOR)/16+1)*16;
    pNew=new char[iNewSize];
    this->iAllowableCharacterCount=iNewSize-1;
    strcpy(pNew,this->pStrBuffer);
    delete [] this->pStrBuffer;
    this->pStrBuffer=pNew;
    this->pStrBuffer[iLen]=ch;
    this->pStrBuffer[iLen+1]='\0';
 }

 return *this;
}


String& String::operator+(const char* pChar) //Overloaded operator + (Adds char literals
{                                             //or pointers to Asciiz Strings)
 int iLen,iNewSize;
 char* pNew;

 iLen=strlen(this->pStrBuffer)+strlen(pChar);
 if(iLen<this->iAllowableCharacterCount)
 {
    if(this->pStrBuffer)
       strcat(this->pStrBuffer,pChar);
    else
       strcpy(this->pStrBuffer, pChar);
 }      
 else
 {
    iNewSize=(iLen*EXPANSION_FACTOR/16+1)*16;
    pNew=new char[iNewSize];
    this->iAllowableCharacterCount = iNewSize-1;    
    if(this->pStrBuffer)
    {  
       strcpy(pNew,this->pStrBuffer);
       delete [] pStrBuffer;
       strcat(pNew,pChar);
    }
    else
       strcpy(pNew,pChar);
    this->pStrBuffer=pNew;
 }

 return *this;
}


String& String::operator+(const String& strRight)  //Overloaded operator + Adds 
{                                                  //Another String to the left 
 int iLen,iNewSize;                                //operand
 char* pNew;

 iLen=strlen(this->pStrBuffer) + strlen(strRight.pStrBuffer);
 if(iLen < this->iAllowableCharacterCount)
 {
    if(this->pStrBuffer)
       strcat(this->pStrBuffer,strRight.pStrBuffer);
    else
       strcpy(this->pStrBuffer,strRight.pStrBuffer);
 }
 else
 {
    iNewSize=(iLen*EXPANSION_FACTOR/16+1)*16;
    pNew=new char[iNewSize];
    this->iAllowableCharacterCount=iNewSize-1;    
    if(this->pStrBuffer)
    {
       strcpy(pNew,this->pStrBuffer);
       delete [] pStrBuffer;
       strcat(pNew,strRight.pStrBuffer);
    }
    else
       strcpy(pNew,strRight.pStrBuffer);
    this->pStrBuffer=pNew;
 }

 return *this;
}


String String::Left(unsigned int iNum)
{
 unsigned int iLen,i,iNewSize;
 String sr;

 iLen=strlen(this->pStrBuffer);
 if(iNum<iLen)
 {
    iNewSize=(iNum*EXPANSION_FACTOR/16+1)*16;
    sr.iAllowableCharacterCount=iNewSize-1;
    sr.pStrBuffer=new char[iNewSize];
    for(i=0;i<iNum;i++)
        sr.pStrBuffer[i]=this->pStrBuffer[i];
    sr.pStrBuffer[iNum]='\0';
    return sr;
 }
 else
 {
    sr=*this;
    return sr;
 }
}


String String::Remove(const char* pToRemove, bool blnCaseSensitive)
{
 int i,j,iParamLen,iReturn=0;
 bool blnFound=false;

 if(*pToRemove==0)
    return true;
 iParamLen=strlen(pToRemove);
 i=0, j=0;
 do
 {
  if(pStrBuffer[i]==0)
     break;
  if(blnCaseSensitive)
     iReturn=strncmp(pStrBuffer+i,pToRemove,iParamLen);  //strncmp
  else
     iReturn=strnicmp(pStrBuffer+i,pToRemove,iParamLen); //_strnicmp
  if(iReturn!=0)
  {
     if(blnFound)
        pStrBuffer[j]=pStrBuffer[i];
     j++, i++;
  }
  else   //made a match
  {
     blnFound=true;
     i=i+iParamLen;
     pStrBuffer[j]=pStrBuffer[i];
     j++, i++;
  }
 }while(1);
 if(blnFound)
    pStrBuffer[i-iParamLen]='\0';
 String sr=pStrBuffer;

 return sr;
}


String String::Right(unsigned int iNum)  //Returns Right$(strMain,iNum)
{
 unsigned int iLen,i,j,iNewSize;
 String sr;

 iLen=strlen(this->pStrBuffer);
 if(iNum<iLen)
 {
    iNewSize=(iNum*EXPANSION_FACTOR/16+1)*16;
    sr.iAllowableCharacterCount=iNewSize-1;
    sr.pStrBuffer=new char[iNewSize];
    j=0;
    for(i=iLen-iNum;i<=iLen;i++)
    {
        //printf(_T("%u\t%u\t%c\n"),i,j,pStrBuffer[i]);
        sr.pStrBuffer[j]=this->pStrBuffer[i];
        j++;
    }
    sr.pStrBuffer[iNum]='\0';
    return sr;
 }
 else
 {
    sr=*this;
    return sr;
 }
}


String String::Mid(unsigned int iStart, unsigned int iCount)
{
 unsigned int iLen,i,j,iNewSize;
 String sr;

 iLen=strlen(this->pStrBuffer);
 if(iStart && iStart<=iLen)
 {
    if(iCount && iStart+iCount-1<=iLen)
    {
       iNewSize=(iCount*EXPANSION_FACTOR/16+1)*16;
       sr. iAllowableCharacterCount=iNewSize-1;
       sr.pStrBuffer=new char[iNewSize];
       j=0;
       sr.pStrBuffer=new char[iNewSize];
       for(i=iStart-1;i<iStart+iCount-1;i++)
       {
           sr.pStrBuffer[j]=this->pStrBuffer[i];
           j++;
       }
       sr.pStrBuffer[iCount]='\0';
       return sr;
    }
    else
    {
       sr=*this;
       return sr;
    }
 }
 else
 {
    sr=*this;
    return sr;
 }
}


int String::InStr(const char ch)
{
 int iLen,i;

 iLen=strlen(this->pStrBuffer);
 for(i=0;i<iLen;i++)
 {
     if(this->pStrBuffer[i]==ch)
        return (i+1);
 }

 return 0;
}


int String::InStr(const char* pStr, bool blnCaseSensitive)
{
 int i,iParamLen,iRange;

 if(*pStr==0)
    return 0;
 iParamLen=strlen(pStr);
 iRange=strlen(pStrBuffer)-iParamLen;
 if(iRange>=0)
 {
    for(i=0;i<=iRange;i++)
    {
        if(blnCaseSensitive)
        {
           if(strncmp(pStrBuffer+i,pStr,iParamLen)==0)   //strncmp
              return i+1;
        }
        else
        {
           if(strnicmp(pStrBuffer+i,pStr,iParamLen)==0)  //_strnicmp
              return i+1;
        }
    }
 }

 return 0;
}


int String::InStr(const String& s, bool blnCaseSensitive)
{
 int i,iParamLen,iRange,iLen;

 iLen=strlen(s.pStrBuffer);
 if(iLen==0)
    return 0;
 iParamLen=iLen;
 iRange=strlen(pStrBuffer)-iParamLen;
 if(iRange>=0)
 {
    for(i=0;i<=iRange;i++)
    {
        if(blnCaseSensitive)
        {
           if(strncmp(pStrBuffer+i,s.pStrBuffer,iParamLen)==0)  //strncmp
              return i+1;
        }
        else
        {
           if(strnicmp(pStrBuffer+i,s.pStrBuffer,iParamLen)==0) //_strnicmp
              return i+1;
        }
    }
 }

 return 0;
}


void String::LTrim()
{
 unsigned int i,iCt=0,iLenStr;

 iLenStr=this->LenStr();
 for(i=0;i<iLenStr;i++)
 {
     if(pStrBuffer[i]==32||pStrBuffer[i]==9)
        iCt++;
     else
        break;
 }
 if(iCt)
 {
    for(i=iCt;i<=iLenStr;i++)
        pStrBuffer[i-iCt]=pStrBuffer[i];
 }
}


void String::RTrim()
{
 unsigned int iCt=0, iLenStr;

 iLenStr=this->LenStr()-1;
 for(unsigned int i=iLenStr; i>0; i--)
 {
     if(this->pStrBuffer[i]==32 || this->pStrBuffer[i]==9)
        iCt++;
     else
        break;
 }
 this->pStrBuffer[this->LenStr()-iCt]=0;
}


void String::Trim()
{
 this->LTrim();
 this->RTrim();
}


unsigned int String::ParseCount(const char c)  //returns one more than # of
{                                              //delimiters so it accurately
 unsigned int iCtr=0;                          //reflects # of strings delimited
 char* p;                                      //by delimiter.

 p=this->pStrBuffer;
 while(*p)
 {
  if(*p==c)
     iCtr++;
  p++;
 }

 return ++iCtr;
}


void String::Parse(String* pStr, char delimiter)
{
 unsigned int i=0;
 char* pBuffer=0;
 char* c;
 char* p;

 puts("Entering Parse(String* pStr, char delimiter)");
 pBuffer=new char[this->LenStr()+1];
 printf("  pBuffer = %u\n",(unsigned int)pBuffer);
 if(pBuffer)
 {
    p=pBuffer;
    c=this->pStrBuffer;
    while(*c)
    {
     if(*c==delimiter)
     {
        pStr[i]=pBuffer;
        printf("  Assigned pStr[%u] In Parse()\n",i);
        printf("  pStr[%u]  = %s\n",i,pStr[i].lpStr());
        printf("  pStr[%u]  = %u\n",i,(unsigned int)pStr[i].lpStr());
        printf("  &pStr[i] = %u\n\n",(unsigned int)&pStr[i]);
        p=pBuffer;
        i++;
     }
     else
     {
        *p=*c;
        p++;
        *p=0;
     }
     c++;
    }
    pStr[i]=pBuffer;
    printf("  Assigned pStr[%u] In Parse()\n",i);
    printf("  pStr[%u]  = %s\n",i,pStr[i].lpStr());
    printf("  pStr[%u]  = %u\n",i,(unsigned int)pStr[i].lpStr());
    printf("  &pStr[i] = %u\n",(unsigned int)&pStr[i]);
    delete [] pBuffer;
 }
 puts("Leaving Parse(String* pStr, char delimiter)\n");
}


int String::iVal()
{
 return atoi(this->pStrBuffer);  //atoi
}


String String::CStr(const int iNum)
{
 String sr;
 sprintf(sr.pStrBuffer,"%d",iNum);
 return sr;
}


String String::CStr(const unsigned int iNum)
{
 String sr;
 sprintf(sr.pStrBuffer,"%u",iNum);
 return sr;
}


String String::CStr(const short int iNum)
{
 String sr;
 sprintf(sr.pStrBuffer,"%d",iNum);
 return sr;
}


String String::CStr(const double dblNum)
{
 String sr(32);
 sprintf(sr.pStrBuffer,"%f",dblNum);
 return sr;
}


int String::LenStr(void)
{
 return strlen(this->pStrBuffer);
}


char* String::lpStr()
{
 return pStrBuffer;
}


void String::Print(bool blnCrLf)
{
 printf("%s",pStrBuffer);
 if(blnCrLf)
    printf("\n");
}


String::~String()   //String Destructor
{
 printf("\nEntering String Destructor!\n");
 printf("  this       = %u\n", (unsigned int)this);
 printf("  pStrBuffer = %u\t%s\n",(unsigned int)pStrBuffer,pStrBuffer);  
 delete [] pStrBuffer;
 pStrBuffer=0;
 printf("Leaving String Destructor!\n\n");
}


