//Strings.h
#if !defined(STRINGS_H)
#define STRINGS_H
#define EXPANSION_FACTOR      2
#define MINIMUM_ALLOCATION    8

class String
{
 public:
 String();                                //Uninitialized Constructor
 String(const char);                      //Constructor Initializes String With char
 String(const char*);                     //Constructor Initializes String With char*
 String(const String&);                   //Constructor Initializes String With Another String (Copy Constructor)
 String(const int);                       //Constructor Initializes Buffer To Specific Size
 String& operator=(const char);           //Assigns char To String
 String& operator=(const char*);          //Assigns char* To String
 String& operator=(const String&);        //Assigns one String to another (this one)
 String& operator+(const char);           //For adding char to String
 String& operator+(const char*);          //For adding null terminated char array to String
 String& operator+(const String&);        //For adding one String to Another
 bool operator==(const String);           //For comparing Strings
 String Left(unsigned int);               //Returns String of iNum Left Most chars of this
 String Right(unsigned int);              //Returns String of iNum Right Most chars of this
 String Mid(unsigned int, unsigned int);  //Returns String consisting of number of chars from some offset
 String Remove(const char*, bool);        //Returns A String With A Specified char* Removed
 int InStr(const char);                   //Returns one based offset of a specific char in a String
 int InStr(const char*, bool);            //Returns one based offset of a particular char pStr in a String
 int InStr(const String&, bool);          //Returns one based offset of where a particular String is in another String
 void LTrim();                            //Removesleading spaces/tabs
 void RTrim();                            //Removes spaces/tabs from end
 void Trim();                             //Removes both leading and trailing whitespace 
 unsigned int ParseCount(const char);     //Returns count of Strings delimited by a char passed as a parameter
 void Parse(String*, char);               //Returns array of Strings in first parameter as delimited by 2nd char delimiter
 String CStr(const int);                  //Converts String to integer
 String CStr(const unsigned int);         //Converts String to unsigned int
 String CStr(const short int);            //Converts String to 16 bit int
 String CStr(const double);               //Converts String to double
 int iVal();                              //Returns int value of a String
 int LenStr(void);                        //Returns length of string
 char* lpStr();                           //Returns address of pStrBuffer member variable
 void Print(bool);                        //Outputs String to Console with or without CrLf
 ~String();                               //String Destructor

 private:
 char* pStrBuffer;
 int   iAllowableCharacterCount;
};
#endif
